#!/opt/bin/perl -I/opt/ras/lib:/opt/ras/lib/auto -d

use PDM;
use PDM::SAF;
use Debug;

System->set_home("/tmp/SAF");
$TAG = $ARGV[0];


$saf = PDM::SAF->new({ file => "http"});

while (($old = $saf->read() )) {
  $ix = index($old, "\n");
  print "OLD=" . substr($old,0,$ix) . "\n";
     $err = 1;
     if ($err) {
       Debug->err(CANNOT_HTTP => "ProviderHttp: $url: $resp");
       $saf->failed($old);
     }
  }    
$saf->done;


for ($x=0; $x <= 10; $x++) {
   $data = "testtest$TAG $x\n" x 5;
   $err = 1;
   if ($err) {
      $saf->write($data);
   }
}

