{
    /usr/sbin/swap -s 2>&- ||
    /etc/pstat -s 2>&-
} |
/bin/awk '
    {
        for (i = 1; i <= NF; i++) {
            if ($i ~ /used/) break;
            used = substr ($i, 1, length ($i) - 1);
            if (used < 10.24) {
                used_str = $i;
            }
            else {
                used_str = sprintf ("%.0f", used / 1024);
            }
        }

        for (i = 1; i <= NF; i++) {
            if ($i ~ /avail/) break;
            avail = substr ($i, 1, length ($i) - 1);
            if (avail < 10.24) {
                avail_str = $i;
            }
            else {
                avail_str = sprintf ("%.0f", avail / 1024);
            }
        }

        printf ("%'"$offset"'s %.0f total, %s used, %s available\n"\
            , "SWAP:"                   \
            , (used + avail) / 1024     \
            , used_str                  \
            , avail_str                 \
        );
    }
'

