package DeviceId;
#  $Name:  $ 
#  $Id: DeviceId.pm,v 1.2 2000/11/12 20:03:26 ccadieux Exp $

use Carp;

#
# $id = DeviceId->new({
#		name     => , 	
#		category => , 
#		ip       => , 
#   wwn      => ,
#   serial   => ,
#   ref      => ,

sub new {
  my($class, $arg) = @_;

  my($id) = {};

  $id->{name} = $arg->{name} || croak("Id must contain a name!");
  $id->{category} = $arg->{category} || croak("Id must contain a category!");
  $id->{ip}   = $arg->{ip};
  $id->{ref}   = $arg->{ref};
  $id->{wwn}  = $arg->{wwn};
  $id->{serial} = $arg->{serial};

  bless($id, 'DeviceId');
  return $id;
}

sub category {
  my($id) = @_;
  return $id->{category};
}

sub name {
  my($id) = @_;
  return $id->{name};
}

sub serial {
  my($id) = @_;
  return $id->{serial};
}

sub ref {
  my($id) = @_;
  return $id->{ref};
}

sub ip {
  my($id) = @_;
  return $id->{ip};
}

sub wwn {
  my($id) = @_;
  return $id->{wwn};
}


sub toString {
  my($id) = @_;
  my($o) = "$id->{category}: $id->{name}:";
  if ($id->{ip}) {
    $o .= " IP=$id->{ip},";
  }
  if ($id->{wwn}) {
    $o .= " WWN=$id->{wwn},";
  }
  if ($id->{serial}) {
    $o .= " SERIAL=$id->{serial},";
  }
  chop($o);
  return $o;
}
  
1;


      
