package Fibre::History;

use Util;
use System;
use FibreStat;
use Data::Dumper;
use BK2;
use Time::JulianDay;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC


sub run {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);
  my(@readerr, @writeerr);
  my($date1);
  if ($q->{ACTION} =~ "Select") {
    $date1 = "MM/DD HH:MM";
  } elsif ($q->{ACTION} eq "Run") {
    $date1 = $q->{date};
  } elsif ($q->{date}) {
    $date1 = substr(&displayDate($q->{date}), 0, -3);
  } else {
    $date1 = "MM/DD HH:MM";
  }

  print "<table border=0><tr><td></table>
   <form><input type=hidden name=GO value=FibreGUI::test2>
     <input type=hidden name=option value=10>
   <table width=95% border=1 cellspacing=0 bgcolor=white>
<tr><td bgcolor=#666699 colspan=5>
  <table border=0 cellspacing=0 cellpadding=0 width=100%>
  <tr><td><font color=white><b>
           Select SCSI Errors from /var/adm/messages:
           <input type=submit name=ACTION value=SelectRead>
           <input type=submit name=ACTION value=SelectWrite>
           <input type=submit name=ACTION value=SelectSeq>
            </td>
  <td align=right><b><font color=white>or Enter Date:&nbsp;
  <input type=text size=13 name=date value=\"$date1\">&nbsp;
  <input type=submit name=ACTION value=Run>
      </table>
  </td>
  </form>
  ";
#Jan 31 10:40:05 invader         SCSI transport failed: reason 'tran_err': retrying command

  $grep = System->get_home() . "/bin/grep";
  if ($q->{ACTION} eq "SelectRead") {
    @rwerr = `grep "SCSI transport failed" /var/adm/messages.1 /var/adm/messages`;

  } elsif ($q->{ACTION} eq "SelectWrite") {
    @rwerr = `grep "(scsi parity error)" /var/adm/messages.1 /var/adm/messages`;

  } elsif ($q->{ACTION} eq "SelectSeq") {
    @rwerr = `$grep -e "(scsi parity error)\nSCSI transport failed" /var/adm/messages.1 /var/adm/messages`;


  } elsif ($q->{ACTION} eq "Run") {
    print "</table>";
    &select($q);
    return;

  } elsif ($q->{date}) {
    print "</table>";
    &select($q);
    return;
  }

  if ($q->{ACTION} eq "Select") {
     print "
<tr bgcolor=#E0E0E0>
    <th>No</td>
    <th>Type</td>
    <th>File</td>
    <th>Date</td>
    <th>Error</td>
     ";
  }
  $cnt=0;
  $info = substr($q->{ACTION},6);
  print "<tr><td colspan=5><b>$info Errors</td>";
  for ($x=$#rwerr; $x >= 0; $x--) {
    $l = $rwerr[$x];
    $type = ($l =~ /(scsi parity error)/)? "<b>write</b>":"read";
    $i = index($l,":");
    $file = substr($l,8, $i-8);
    $l0 = substr($l,$i+1);
    chop($l0);
    my($mess) = substr($l0,16);
    ($date, $date0) = &formatDate($l0);
    $info = Util->encode($mess);
    $url = "<a href=\"/?GO=FibreGUI::test2&option=10&date=$date&mess=$info\">$date0</a>";
    print "<tr><td>$cnt<td>$type<td>$file<td>$url<td>$mess";
    last if ($cnt++ > 100);
  }

  print "</table>";

}


sub formatDate {
  my($l0) = @_;
  my($m) = Util->MTH(substr($l0,0,3));
  my($day) = substr($l0,4,2);

  $date = sprintf("%2.2d", $m) . sprintf("%2.2d", $day) . 
          substr($l0,7,2) . substr($l0,10,2) . substr($l0,13,2);
  $date0 = substr($date,0,2) . "/" . substr($date,2,2) . " " . 
          substr($l0,7,8);
  return ($date, $date0);
}

sub displayDate {
   my($date) = @_;
   return substr($date,0,2) . "/" . substr($date,2,2) . " " . 
           substr($date,4,2) . ":" . substr($date,6,2) . ":" . substr($date,8);
}

sub minutes {
  my($d1) = @_;
  my($jd) = julian_day(2001,substr($d1,0,2), substr($d1,2,2));
  return $jd * 24*60 + (substr($d1,4,2)*60) + substr($d1,6,2);
}

sub select {
  my($q) = @_;

  if ($q->{ACTION} eq "Run") {
     @a = split(/ +/, $q->{date});
     @b = split(/[\-\/]/, $a[0]);
     @c = split(/:/, $a[1]);
     $month = $b[0];
     $day   = $b[1];
     $hour  = $c[0];
     $min   = $c[1];
     $date = "$month$day$hour$min";
     $dateS = &displayDate($date);
     $title= "Date: $dateS ";
  } else {
    $date= $q->{date};
    $dateS = &displayDate($date);
    $title= "<b>Message:</b><small> $dateS $q->{mess}";
  }
  my($minutes) = $q->{minutes} || 10;

  $db = BK2->new({file     => System->get_home() . "/DATA/Rasstat", 
                  readonly => 1, 
                     debug => 0, 
                       len => [20,10] 
                  });
  $csr = $db->cursor(1); # date index
  %C = () ; %CNT = ();

#             hba|enc_name|comp_name|type
# 0128171508, 0|e|r06|a

  for (($el = $csr->getGT($date,"")) ; $el; $el = $csr->prev() ) {
     $delta = &minutes($date) - &minutes($el->[0]);
     if ($delta > $minutes) { # look back 1 hour
#         print "stop at $el->[0], $date<br>";
         last;
     }
     my(@a) = split(/\t/, $el->[2]);
     $d1    = $el->[0];
     $comp  = $el->[1];
     $C{$comp}{$d1} = $el->[2];
     $CNT{$comp}{cnt}++;
     $CNT{$comp}{date} = $d1;
  }
  $csr->close();
  $csr = $db->cursor(2);
  foreach $c (keys %CNT) {
    if ($CNT{$c}{cnt} == 1) {  # found only one, need an older one to calc. delta
       $el = $csr->getLT($CNT{$c}{date}, $c);
       if ($el && $el->[1] eq $c) {
          $C{$c}{$el->[0]} = $el->[2];
       }
    }
  }
  $csr->close();
  $db->close();

  my(%D);
  foreach $c (sort keys %C) {
     $p = $C{$c};
     $first = "";
     foreach $d (sort keys %$p) {
         $val  = $p->{$d};
         if ($first) {
            if (($v = &delta($first, $val)) ) {
               $D{$d}{$c} = $v;
            }
         }
         $first = $val;
     }
  }
  print "<table border=0><tr><td></table>
     <form><input type=hidden name=GO value=FibreGUI::test2>
      <input type=hidden name=option value=10>
      <input type=hidden name=date value=\"$date\">
      <input type=hidden name=mess value=\"$q->{mess}\">
     <table border=1 cellspacing=0 width=95% bgcolor=white>";
  $f = "<font color=white>";
  print "<tr><td colspan=7>$title</td>
    <td colspan=4>&nbsp;<b>Minutes Back:</b><input type=text name=minutes size=3 value=$minutes>&nbsp;<input type=submit name=ACTION value=GO>";

  print "<tr bgcolor=#666699>
     <th>$f Date
     <th>$f Hba
     <th>$f Type
     <th>$f Encl<th>$f Component 
     <th>$f Link<th>$f Signal<th>$f Seq<th>$f CRC<th>$f Sync<th>$f Word</tr>";
  %NAMES = (a => 'A5K', s=>'Switch', t=>'T3');
  foreach $d (reverse sort keys %D) {
     $p = $D{$d};
     foreach $c (sort keys %$p) {
         my(@a) = split(/\|/, $c);
         $v = $p->{$c};
         $d1 = displayDate($d);
         print "<tr>
   <td>&nbsp;$d1
   <td>&nbsp;$a[0]
   <td>&nbsp;$NAMES{$a[3]}
   <td>&nbsp;$a[1]
   <td>&nbsp;$a[2]
   <td><b>&nbsp;$v->[1] <td><b>&nbsp;$v->[2] <td><b>&nbsp;$v->[3]
   <td><b>&nbsp;$v->[4] <td><b>&nbsp;$v->[5] <td><b>&nbsp;$v->[6]</tr>";
     }
  }
  print "</table></form>";
}

sub delta {
  my($old, $new) = @_;
  my($x);
  my(@o) = split(/\t/, $old);
  my(@n) = split(/\t/, $new);
  my(@d);
  my($one) = 0;
  for ($x=1; $x <= 6; $x++) {
     if ($n[$x] - $o[$x]) {
        $d[$x] = $n[$x] - $o[$x] ;
        $one= 1;
     }
  }
  if ($one) {
    return \@d;
  } else {
    return undef;  # nothing when all zero
  }
}
     

1;
