package Fibre::T3Data;

use Util;
use System;


sub run {
 my($q) = @_;

 my($renv, $devs, $host,$notifs) = PDM::ConfigFile->read;
 my($r, $summ) = FibreStat::t3_luxdisc($q,
                  {cache => $cache, debug => $debug , devs => $devs });

 my($RF) =  System->get_home() . "/DATA/tmp/t3_crcs";
 my($out);
 $date = Util->get_today();

 %OLD = ();
 $old_date = "";
 $now = time;
 $age = 0;
 if (open(O, $RF)) {
   $old_date = Util->get_file_created($RF);
   ($age_mins, $age_secs) = Util->getFileAge($RF, "ms");

   while ($l = <O>) {
     my(@a) = split(/\t/, $l,2);
     $OLD{$a[0]} = "$a[0]\t$a[1]";
   }
   close(O);
 }

 $out .= "<pre><b>
 T3 FC Counters - from '$old_date' ($age_mins mins $age_secs secs)
                    to '$date' </b><pre>";

 $format = " %-4s %-10.10s %-10s%12s%12s%12s%12s%12s%12s\n";
 $format2 = $format;

# LINKFAIL LOSSSYNC LOSSSIG PROTOERR INVTXWORD INVCRC

# @title  = ('Code', 'Enc', 'Comp', 'LinkFail', 'LossSig', 'Seq', 'InvCRC', 'LossSync', 'InvTxW');
#                                    1           5           2           3           6    4
 @title  = ('Code', 'Enc', 'Comp', 'LinkFail', 'LossSync', 'LossSig', 'ProtoErr', 'InvTxWrd','InvCRC');

 $out .= sprintf("<b>$format2", @title);
# $out .= " " . ("-" x 100) . "\n";

 open(O, ">$RF");
 foreach $l (sort @$r) {
   print O $l . "\n";
   if (substr($l,0,1) eq "#") {
      $save .= $l . "\n";
      next;
   }
   my(@a) = split(/\t/, $l);
   my(@b) = split(/\|/, $a[0]);

   my(@old) = split(/\t/, $OLD{$a[0]});

   my(@diff) = ();
   $data = "";
   foreach $x (1,5,2,3,6,4) {
      $y = $a[$x] - $old[$x];
      if (!defined($a[$x])) {
        $data .= " " x 11 . "-";
      } elsif ($y > 0) {
        $len = length("$y/$a[$x]");
        $data .= " " x (12-$len) . "<font color=red><b>$y</b></font>/$a[$x]";
      } else {
        $len = length("$a[$x]");
        $data .= " " x (12-$len) . $a[$x];
      }
   }
   $bg = ($cnt2++ % 2 == 0) ? "bgcolor=#F0F0F0":"";
   $out .= "<tr><td $bg><pre>" . sprintf(" %-4s %-10.10s %-10s%s\n", ($b[0]|| "-"), $b[1], $b[2], $data);

 }
 close(O);

# $out .= " " . ("-" x 100) . "\n";
 $out .= "<tr><td><pre>\n$save\n";
 print "&nbsp;<table width=98% border=0 cellpadding=0 cellspacing=0 bgcolor=white><tr><td>$out</table>";


}
1;

