package Jade;
use Util;
use System;
use strict;


sub get_xfer {
  my($q) = @_;
  if ($q->{command} eq "list") {
     &list($q);
  } elsif ($q->{command} eq "data") {
     &data($q);
  } elsif ($q->{command}) {
     print "ERR\t001\tInvalid command: $q->{command}\n";
  } else {
     print "ERR\t002\tMissing command\n";
  }
}

sub list {
  my($q) = @_;
  my($l);
  print "OK\t<pre>\n";
  my $host = System->hostname();

  opendir(O, System->get_home(). "/DATA/OLD_REPORTS");
  my @files = readdir(O);
  closedir(O);
  foreach my $f (@files) {
      my($type, $key) = split(/\:/, $f);    
      next if (!$key);
      next if ($q->{type} && $q->{type} ne lc($type));
      print "$type\t$host\t$f\n";
  }
}


sub data {
  my($q) = @_;
  my($VAR1);

  my $f = System->get_home() . "/DATA/OLD_REPORTS/$q->{key}";

  if (open(O, $f) ) {
     my @a = <O>;
     close(O);
     eval "@a";
     if ($VAR1) {
        print "OK\t<pre>\n";
        print "_created\t" . $VAR1->{_created} ."\n";
        my $id  = $VAR1->{_id};
        foreach my $k (keys %$id) {
           print "_$k\t$id->{$k}\n";
        }
        my $val = $VAR1->{_value};
        foreach my $k (sort keys %$val) {
           print "$k\t$val->{$k}\n";
        }
     } else {
       print "ERR\t004\tReport $f invalid\n";
     }
  } else {
     print "ERR\t003\tReport $f not found\n";
  }
}
1;
