package PDM::Modules;
#  $Name:  $ 
#  $Id: Modules.pm,v 1.6 2001/03/23 00:41:36 ccadieux Exp $

use System;
use Debug;
sub revision {'$Revision: 1.6 $'}


#
#  read and load modules
#  STATIC call
#
sub load {
  my($pdm, $dir, $skip, $prefix) = @_;
  my($mod, @admins);
  my(@mods) = $pdm->read($dir, $skip, $prefix);

  foreach $mod (@mods) {
     if (eval "require \"$dir/${mod}.pm\"") {

     } else {
        Debug->err(LOAD_MODULE => "Error in load_$dir: $@ ");
        print "Error in PDM::Modules::load $dir/$mod: $@ <br>";
     }
  }
  return @mods;
}


# reads packages in a dir, return a list of file names without the '.pm'
# called by rasagent load_agents

sub read {
  my($pdm, $dir, $skip, $prefix) = @_;
  my($d0, @mods, $d);

  if (opendir(O, System->get_home . "/lib/$dir")) {
    while ($d0 = readdir(O)) {
       next if (substr($d0,-3) ne ".pm");
       $d = substr($d0, 0, -3);
       next if ($skip && $d eq $skip);
       next if ($prefix && substr($d,0,length($prefix)) ne $prefix);
       push(@mods, $d);
    }
    closedir(O);
    return @mods;
  } else {
    return ();
  }
}

1;
