package Rules;
#  $Name:  $ 
#  $Id: Rules.pm,v 1.3 2001/08/27 17:40:56 ccadieux Exp $

use Agent;
#use XML::Simple2; 

%S = ();
%V = ();
$read = 0;
#
# format
# [t300]
# elem_type.attribute.disabled = red
# elem_type.attribute.enabled = green
# Ex: 
# controller.fruState.enabled = green

sub read {
  my($class, $f) = @_;
  
  return \%V if ($read);

  if (!open(O,$f)) {
     return undef;
  }
  
  while ($l = <O>) {
    chop($l);
    next if (substr($l,0,1) eq "#" || $l =~ /^ *$/);
    if ($l =~ /\[(.+)\]/) {
        @a = split(/_/, $1);
        $section = $a[0];
        $S{$section} = (defined($S{$section}))? ++$S{$section} : 0;
        $V{$section}[$S{$section}]{_name} = $a[1];
    } else {
        $i = index($l, "=");
        $k = substr($l,0,$i);
        $v = substr($l,$i+1);
        $V{$section}[$S{$section}]{$k} = $v;
    }
  }
  close(O);
  $read = 1;
  return \%V;
}

sub get_rules {
  my($class, $type) = @_;
  return $V{$type};
}


sub add_conclusion {
  my($agent, $type, $line) = @_;

  $o = XMLinput($line , (keeproot => 0)) || {}; 
  
  $p = $V{$type};
  foreach $att (keys %$o) {
     print "$att = $o->{$att} \n";
  }
}


1;
