package Serialize;
#  $Name:  $ 
#  $Id: Serialize.pm,v 1.2 2000/11/12 20:03:37 ccadieux Exp $


sub join {
  my($class, $h) = @_;

  if (ref($h) eq "HASH") { 
     return Serialize->hash_join($h);

  } elsif (ref($h) eq "ARRAY") {
     return join('||', @$h);
  }
  return undef;
}

sub hash_join {
  my($class,$h) = @_;
  my($s);
  foreach $val (keys %$h) {
    $s .= "$val=$h->{$val}||";
  }
  if ($s) {
     chop($s) ; chop($s);
  }
  return $s;
}

sub array_split {
  my($class, $h) = @_;

  my(@a) = split(/\|\|/, $h);
  return \@a;
}

sub hash_split {
  my($class, $s) = @_;
  my(%h, $x, $i, $key, $val);
  my(@a) = split(/\|\|/, $s);
  foreach $x (@a) {
     $i = index($x, "=");
     $key = substr($x,0,$i);
     $val = substr($x,$i+1);
     $h{$key} = $val;
  }
  return \%h;
}

1;
