package Shuttle;
#  $Name:  $ 
#  $Id: Shuttle.pm,v 1.3 2001/04/26 17:40:42 ccadieux Exp $

use System;
use Util;
use Archive::Tar;
use IO::Socket;


sub get_port {
  return 5483;
}

sub format {
  my($class, $data) = @_;
  my($hostid, $utc, $utcm, $tar, $out, $xml);
  my($TMP) = "/tmp/rasagent.out";

  $hostid = System->hostid;
  $utc = time;
  $utcm = int(time / 60);
  $lhfzone = Util->lhfZone($utc);

  $xml =<<EOF;
<?xml version="1.0" standalone="no"?>
<!DOCTYPE SRSL SYSTEM "srsl.dtd">
<SRSL>
<msgType>C</msgType>
<agentVersion>1.0</agentVersion>
<cfgVersion>1.0</cfgVersion>
<hostId>$hostid</hostId>
<lhfSecs>$utc</lhfSecs>
<lhfZone>$lhfzone</lhfZone>
<collMins>$utcm</collMins>
<collVersion>1.0</collVersion>
</SRSL>
<collOutput>
EOF
  
   
   $tar =  Archive::Tar->new();
   $tar->add_data("Agent.events",$data);
   $tar->write($TMP, 1);
   $out = $xml;
   open(O, $TMP);
   while ($len = read(O,$l, 1000) ) {
     $out .= $l;
   }
   close(O);
   $out .= "\n</collOutput><SRSLRealEnd>";
   return $out;
}




$error = "";

sub send {
  my($class, $address, $mess) = @_;

  if (!($sock = IO::Socket::INET->new(PeerAddr => "$address:5483" ))) {
     $error = "INET->new $!";
     return undef;
  }
  $l = 0;
  $len = length($mess);
  while ($l < $len) {
     $l += $sock->send(substr($mess,$l));
  }
  $l = $sock->recv($answer,20);
  return $answer;
}


1;
