package string;
sub rtrim {
  local($s) = @_;

  $s =~ /( *)$/;
  substr($s,0,length($s) - length($1));
}

sub ltrim {
  local($s) = @_;

  $s =~ /^( *)/;
  substr($s,length($1),length($s));
}

sub trim {
  local($s) = @_;
  local($left);

  $s =~ /^( *)/;
  $left = length($1);
  $s =~ /( *)$/;
  substr($s,$left,length($s) - length($1) - $left);
}

sub prgm_name {
  local($patt) = @_;
  local($x) ;
  $x = rindex($0,$patt);
  substr($0,$x);
}
  

1; 
