#!/opt/ras/perl/perl5 -I/opt/ras/lib:/opt/ras/lib/site

use Event;
use Data::Dumper;


$e = Event->new('install_event', 0, { ras_hostid => "123456", wwn => "WWN" },
         [    
            Event->new('element_disc_event', 1, undef, 
              [ 
                 Element->new('t300', {id => 1, key1 => "ssn:101010", created => $today}),
                 Element->new('disk', {id => 2, key1 => "ssn:101010"}),
                 Element->new('disk', {id => 3, key1 => "ssn:101011"}),
              ]),
            Event->new('component_disc_event', 1, undef, 
              [ 
                 Component->new({created => $today, rel => [1, 'slot1', 2]}), 
                 Component->new({created => $today, rel => [1, 'slot2', 3]}), 
              ]),
         ]);


#print Dumper($e);

print $e->to_XML;

