#!/opt/RASAgent/perl/perl5

use XML::Parser;
use XML::Dumper;
use Data::Dumper;

$data = {renv => {dir => "dir1", file => "file1"},
         host1 => {dir => "dir2", file => "file2"},
        };

$xml = &pl2xml($data);

$p   = &xml2pl($xml);

print "dir=$p->{renv}{dir} \n";




sub xml2pl {
  my($xml) = @_;

  my $Parser = XML::Parser->new(Style => 'Tree');
  my $Tree  = $Parser->parse($xml);
  my $Dumper = new XML::Dumper();
  my $Ref = $Dumper->xml2pl($Tree);

  return $Ref;
}


sub pl2xml {
  my($pl) = @_;

  my $dump = new XML::Dumper;
  return $dump->pl2xml($pl);
}


