#!/opt/RASAgent/perl/perl5 -I/opt/RASAgent/lib 
use CC::Email;
$KEY = "12345678901234567890123456";

@lines = <STDIN>;
#open(O,">/opt/RASAgent/log/email0"); print O join('',@lines); close(O);
$email = &parse_message(\@lines);

open(O, ">>/opt/RASAgent/log/emails");
print O "$email->{date}---------\n$email->{message}\n";

close(O);



sub parse_message {
  my($mess) = @_;
  my(%email,  $x, $l, $in, $line0);
  $in = 0;
  $line0 = join('',@$mess);
  $email{complete} = $line0;

  for ($x=0; $x <= $#$mess; $x++) {
     $l = $mess->[$x];
     chop($l);
     $l =~ s/\'/\'\'/g;
     $email{header} .= $l if (!$in);
     if ($l eq "" && $in == 0) {
        $in =1;
     } elsif ($in) {
        $email{message} .= $l . "\n";
     } else {
        if ($l =~ /^Subject: (.*)$/) {
           $email{subject} = $1;

        } elsif ($l =~ /^To: (.*)$/) {
           $email{to} = $1;

        } elsif ($l =~ /^From (.*)$/) {
           $email{from2} = $1;
           $email{ora_date} = &read_date($l);

        } elsif ($l =~ /^From: (.*)$/) {
           $email{from}  = $1;

        } elsif ($l =~ /^Date: (.*)$/) {
           $email{date} = $1;
        }
     }
  }
  ($email{signature}, $email{message}) =  CC::Email::decrypt_email($email{message}, $KEY);
  
  if (!$email{message}) {
    print STDERR "decrypt error: " . $CC::Email::error . "\n";
  }
  if ($email{ora_date} eq "") {
     $email{ora_date} = &read_date("");
  }
  if ($email{localtime} eq "") {
     $email{localtime} = $email{ora_date};

  } else {
     if ($email{localtime} =~ /^(.*:.*:\d\d) .*(\(.*\)')/) {
       $email{localtime} = "$1 $2";
     }
  }
  \%email;
}

sub read_date {
  my($l) = @_;
  my(@a, $m, $d, $y, $t, $out, %M, @s);
  @a = split(/ +/, $l);
  $m = $a[3]; $d = $a[4]; $y = $a[6]; $t = $a[5]; $y += 0;
  if ($d =~ /\d+/ && $y =~ /\d+/) {
     $out = "to_date('$m $d $y $t','MON DD YYYY HH24:MI:SS')";
  } else {
     @s = localtime(time); $s[4]++; $s[5] += 1900;
     $out = "to_date('$s[4] $s[3] $s[5] $s[2]:$s[1]:$s[0]','MM DD YYYY HH24:MI:SS')";
  }

  $out;
}



