package Fibre::Stools;
use TO;

sub header {
  $l1 = "<a href=/?GO=Fibre::Stools::run>Tree</a>";
  $l2 = "<a href=/?GO=Fibre::Stools::topo>Topo</a>";
  print "<table border=0 cellspacing=0 cellpadding=3 width=100%>
  <tr><td><b>Stortools Diagnostic Tools</b>
      <td align=right><b>[ $l1 | $l2 | <a href=/monitorF.html
          target=_parent>Back</a> ]&nbsp;</table>
  ";
}


sub topo {
  my($q) = @_;
  print "<body bgcolor=#F0F0F0>";

  &header;

  eval {
   TO->readTopo("data1"); # get objects in globals
   &topoApplet();
  };
  print "$@";

}

sub run {
  my($q) = @_;
  TO->readTopo("data1"); # get objects in globals

  print "<body bgcolor=#E0E0E0>";
  &header;
  print "<center><table border=0><tr><td></table>
   <table border=1 cellspacing=0 cellpadding=2 width=90% bgcolor=white>
  <tr bgcolor=#666699>
     <th><font color=white>Type
     <th><font color=white>Sub-System
     <th><font color=white>Test
     <th><font color=white>Details
    ";
  %TYPES = (t => "T3", a => "A5K", h => "Hub");
  for ($x=0; $x <= $#$TO::Hosts; $x++) {
    $h = $TO::Hosts->[$x];
    $hbas = $TO::Hosts->[$x]{port};
    $hInfo = $TO::Hosts->[$x]{port_info};
    $hname = $h->{info}{name};
    $hname0 = substr($h->{info}{name},2);
    print "<tr><td><center>Host<td><b>$hname0<td>&nbsp;<td>&nbsp;";

    for ($y=0; $y <= $#$TO::Switches; $y++) {
       $s = $TO::Switches->[$y];
       if (substr($hname,2) eq $s->{info}{host}) {
          $type = $s->{info}{VendorID};
          $name = substr($s->{info}{name},2);
          print "<tr><td><center>$type Switch<td>&nbsp;&nbsp;$name
    <td>&nbsp;<td> $s->{info}{RegisterName}";
       }
    }
    for ($y=0; $y <= $#$TO::Storages; $y++) {
       $s = $TO::Storages->[$y];
       if (substr($hname,2) eq $s->{info}{host}) {
          $info = $s->{info}{RegisterName} || $s->{info}{LGroup};
          $type = $TYPES{$s->{info}{type}};
          $name0 = substr($s->{info}{name},2);
          $test = "<a href=/?GO=Fibre::Stools::get_test&enc=$s->{info}{name}:e target=details>a5k_test</a>";
          $review = "<a href=/?GO=Fibre::Discover::get_details&enc=$s->{info}{name}:e target=details>$name0</a>";
          print "<tr><td><center>$type<td>&nbsp;&nbsp;$review<td>$test<td>$info";
       }
    }
    print "<tr><td colspan=3>";

  }
  print "</table>";
}


sub topoApplet {
  my($q) = @_;

  my($applet);
  $applet =<<EOF;
 <script>
  var a_width =  window.innerWidth  - 10;
  var a_height =  window.innerHeight - 16;
  window.document.writeln(
   '<applet  CODE=VertexApplet.class codebase=Topo archive=topo.jar height=' + a_height + ' width=' + a_width + '>');
  </script>
  <param name=url value="GET=Fibre::Discover::topos">
  <param name=drop1 value="Review|details||GET=Fibre::Discover::details">
  <param name=drop2 value="Run_Test|details||GET=Fibre::Stools::test">
  <param name=browser value="sun">
  </applet>
EOF
  print $applet;
}


sub get_test {
  my($q) = @_;
  my($s);
  my($type, $name0, $comp) = split(/:/, $q->{enc});
  my($name) = "$type:$name0";

  print "<body bgcolor=white>";
  
  TO->readTopo("data1"); # get objects in globals
  if ($q->{ACTION} eq "RunTest") {
    my($a5) = $TO::Storages->[$q->{a5ix}];
    my($dname) = $q->{comp};
    if (!$dname) {
       print "<b>No disk selected!";
    } else {
       &run_a5k_test($a5, $dname);
       return;
    }

  }

#
# :a1:dF1 
#
  if ($type eq "a" && index("d,e", substr($comp,0,1)) >=0) { # a5k disk or enclosure
    my($a5);
    $disk0 = lc(substr($comp,1));
    my($dselect) = "<select name=comp><option value=\"\">[Select Disk]</option>";

    for ($x=0; $x <= $#$TO::Storages; $x++) {
       $s = $TO::Storages->[$x];
       if ($s->{info}{type} eq "a" && $s->{info}{name} eq $name) { # found enc
          $a5ix= $x;
          $a5 = $s;
          my($disks) = $TO::Storages->[$x]{disk_info};
          foreach my $d (sort keys %$disks) {
              next if (substr($d,0,1) eq "s");
              my($d0) = "Disk " . uc($d);
              if ($d eq $disk0) {
                 $dselect .= "<option selected value=$d>$d0</option>";
              } else {
                 $dselect .= "<option value=$d>$d0</option>";
              }
          }
          break;
       }
    }
    $dselect .= "</select>";
   
    print "<table border=0><tr><td></table><form>
     <table border=1 cellspacing=0 cellpadding=2 width=100%>
  <tr bgcolor=#666699> 
  <input type=hidden name=GO value=Fibre::Stools::get_test>
  <input type=hidden name=enc value=\"$q->{enc}\">
  <input type=hidden name=a5ix value=\"$a5ix\">
    <td colspan=2><font color=white><b>A5K Disk Test</td>
 <tr><td bgcolor=#E0E0E0 align=right>Name:
     <td >&nbsp;<b>$name
 <tr><td bgcolor=#E0E0E0 align=right>LGroup:
     <td >&nbsp;<b>$a5->{info}{LGroup}
 
 <tr><td bgcolor=#E0E0E0 align=right>Select Disk:
     <td >$dselect
  </table><b><center>
   <input type=submit name=ACTION value=RunTest>
  </form>
";
   } else {
      print "&nbsp;<p><b>Ignoring this System: $q->{enc}";
   }
}

sub run_a5k_test {
  my($a5, $dname) = @_;

  print "<body bgcolor=white>";

  my($dinfo) = $a5->{disk_info};
  my($disk) = $dinfo->{$dname};

  print "&nbsp;<p><b>Run command a5k_test $disk->{LogicalPath} 0 <br>";
}



1;
