package GUI::Errlog;
#  $Id: Errlog.pm,v 1.9 2001/07/27 23:36:50 ccadieux Exp $

use System;

sub list {
  my($q, $post) = @_;
  my(@S, $out, $tabs);
  print "\n";
  print "<body bgcolor=$main'BGCOLOR>";

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $hid = System->hostid;

  $h = &main::header("Network Storage Agent System Errors");

  $out = "<center>
   $h
   <table border=2 cellspacing=2 cellpadding=0 width=90% ><tr><td bgcolor=white>
   <table border=0 cellspacing=2 bgcolor=#F0F0F0 width=100%>
   <tr><td colspan=3 bgcolor=#666699><b><font color=white>Select an existing Host</td>
   <tr bgcolor=$main'LIGHT><th>Host</th>
       <th>Hostid</th>
       <th>Location</th>
   <tr><td><a href=/?GO=GUI::Errlog::detail&loc=master&name=Master>Master</a></td>
       <td>$hid</td>
       <td>&nbsp;</td>
   ";

  foreach $h (@$host) {
    $out .= "<tr><td><a href=/?GO=GUI::Errlog::detail&loc=$h->{ip}&name=$h->{hostname}>$h->{hostname}</a></td>
                 <td>$h->{hostid}</td>
                 <td>$h->{ip}</td>
            ";
    $cnt++;
  }
  $out .= "</table></table>";

  print $out;
}

sub detail {
  my($q, $post) = @_;

  print "\n<body bgcolor=$main'BGCOLOR>";
  $h = &main::header("Network Storage Agent Error Logfiles: $q->{name}", "95%");
  if ($q->{max} =~ /^\d+/) {
     $MAX = $q->{max} + 0;
  } else {
     $MAX = 25;
  }

  $out = "<center>$h
  <table border=1 cellspacing=0 cellpadding=1 width=95% bgcolor=white>
   <form  method=get>
      <input type=hidden name=GO value=GUI::Errlog::detail>
      <input type=hidden name=loc value=$q->{loc}>
      <input type=hidden name=name value=$q->{name}>
   <tr><td colspan=3 bgcolor=#666699>
     <table border=0 cellspacing=0 cellpadding=0 width=100%>
      <tr><td>
         <font color=white>&nbsp;<b>$MAX most recent Local logfile entries</td>
      </td><td align=right>
       <font color=white><b>#Errors:<small>
     <input type=text name=max size=3 value=$MAX>&nbsp;
     <input type=submit name=ACTION value=Refresh>
   </td></table></table></center><pre>";

  if ($q->{loc} eq "master") {
    print "Accessing local log..<br>";
    $q->{max} = $MAX;
    $out .= &get_readlog($q);

  } else {
    print "Accessing remote log..<br>";
    $url  = Util->makeUrl($q->{loc}, "?GET=GUI::Errlog::readlog&max=$MAX&http=1");
    $out .= Util::Http->get($url, $main::TO) || "Error";
  }

  $out .="&nbsp;<p>&nbsp;</form>";
  print $out;

}

sub get_readlog {
  my($q) = @_;
  my($out, $cnt, $cnt2, $cnt3, @S, @a);

  my($MAX) = $q->{max} || 40;

  if (!open(O, System->get_home() . "/log/errors.log")) {
    if ($q->{http}) {
       print "Cannot read errors.log: $!";
    } else {
       return "Cannot read errors.log: $!";
    }
  }
  $cnt = 0;
  while ($l = <O>) {
     $cnt = 0 if ($cnt > $MAX);
     next if (length($l) <= 2);
     $S[$cnt] = $l;
     $cnt++;
  }
  close(O);
  $cnt2 = $cnt - 1;
  $cnt2 = $MAX if ($cnt < 0);
  $cnt3 = 0;
  while ($cnt3 < $MAX) {
    @a = split(/ +/, $S[$cnt2], 4);
    $out .=  "   $a[0]  $a[1]  $a[2]   $a[3]";
    $cnt2--; $cnt3++;
  }
  if ($q->{http}) {
    print $out;
  } else {
    return $out;
  }
  
}

1;
