#!/opt/bin/perl -I/opt/ras21/lib

use Proc::ProcessTable;

$ref = new Proc::ProcessTable;

foreach $proc (@{$ref->table}) {
  if(@ARGV) {
    next unless grep {$_ == $proc->{pid}} @ARGV;
  }

  print $proc->cmndline() . "\n";
  foreach $field ($ref->fields){
    print $field, ":  ", $proc->{$field}, "\n";
  }
}

# $FORMAT = "%-6s %-10s %-8s %-24s %s\n";
# $t = new Proc::ProcessTable;
# printf($FORMAT, "PID", "TTY", "STAT", "START", "COMMAND");
# foreach $p ( @{$t->table} ){
#   printf($FORMAT,
#          $p->pid,
#          $p->ttydev,
#          $p->state,
#          scalar(localtime($p->start)),
#          $p->cmndline);
# }

# uid:  89871
# gid:  10
# euid:  89871
# egid:  10
# pid:  5000
# ppid:  4987
# pgrp:  5000
# sess:  4987
# priority:  58
# nice:  20
# ttynum:  6291460
# flags:  134234632
# time:  0
# ctime:  44
# timensec:  530000000
# ctimensec:  950000000
# size:  1662976
# rss:  1204224
# wchan:  1631957526
# fname:  ksh
# start:  992475911
# pctcpu:   0.00
# state:  sleep
# onpro:  0
# pctmem:   0.23
# cmndline:  ksh
