package Tree;
#  $Name:  $ 
#  $Id: Tree.pm,v 1.4 2001/06/15 19:54:44 ccadieux Exp $


# level=1 to open one level deep.
# $t = Tree::new({target => 'a.b.c', this => '$this', q => $q, sysgif => '/Web/Doc/gif',
#      bold1   => 1
#      linkall => 1, name => "ROOTNAme" });

sub new {
  my($class, $a) = @_;
  bless($a, 'Tree');
  return $a;
}

# $out = $t->read([ ['SAN/index1','url1','<gif>'],
#                   ['SAN/index2','url2','<gif>'],
#                 ]);

my(@Child, @IDX, @URL,@GIF,@EXTRA, @TARGET);

sub log1 {
  my($t) = @_;
  open(O,">>/tmp/xx"); print O "$t\n"; close(O);
}

%T = ();
sub jread {
  my($tp, $el, $doc) = @_;
  my($j);
  %E = (); %T = ();
  foreach my $a (@$el) {
    $tp->subtree("", $a->[0],  $a->[1]);
  }
  my($js) =<<EOF;
<script language="JavaScript" src="treeMenuCode.js"></script>
<script language="JavaScript">
var m1                 = new TreeMenu();  // This is the main menu.
var treeMenuName       = "myMenu_1.0";    // Make this unique for each tree menu.
var treeMenuDays       = 7;               // Number of days to keep the cookie.
var treeMenuFrame      = "tree";     // Name of the menu frame.
var treeMenuImgDir     = "$tp->{sysgif}";   // Path to graphics directory.
var treeMenuBackground = "";              // Background image for menu frame.
var treeMenuBgColor    = "white";         // Color for menu frame background.
var treeMenuFgColor    = "#000000";       // Color for menu item text.
var treeMenuHiBg       = "#008080";       // Color for selected item background.
var treeMenuHiFg       = "#ffffff";       // Color for selected item text.
var treeMenuFont       = "MS Sans Serif,Arial,Helvetica";    // Text font face.
var treeMenuFontSize   = 1;               // Text font size.
var treeMenuRoot       = "X$tp->{name}";     // Text for the menu root.
var treeMenuFolders    = 0;               // Sets display of '+' and '-' icons.
var treeMenuAltText    = true;   
EOF
  
  $MENU = "m1";
  return $js . $tp->visit("m1",$X{""}) . "parent.treeMenuDisplay();\n</script>\n";
}

sub visit {
  my($tp, $menu, $node) = @_;
  my($x, $o);
  my($item) = 0;
  for ($x=1; $x <= $#$node; $x++) {
     $p = $node->[$x];
     if (ref($p) eq "Dir") {
        $MENU++;
        my($m1) = $MENU;
        $o .= "var $m1 = new TreeMenu();\n";
        $o .= $tp->visit($m1, $p);
        $o .= "$menu.addItem(new TreeMenuItem(\"" . $p->[0] . "\"));\n";
        $o .= "$menu.items[" . ($x-1) . "].makeSubmenu($m1);\n";
     } else {
        $o .= "$menu.addItem(new TreeMenuItem(\"" . $p->[0] . "\",\"" . $p->[1] . "\"));\n";
     }
  }
  return $o;
}

sub findDir {
  my($tp, $v) = @_;
  my($p);
  if (!$X{$v}) {
    $p = Dir->new([$v]);
    $X{$v} = $p;
  } else {
    $p = $X{$v};
  }
  return $p;
}

sub subtree {
  my($tp, $base, $b, $url) = @_;

  my($ix) = index($b, "/", 1); 
  my($p, $j, $inc);
  $j = 0; my($dir);
  my($cd) = $base;
  while ($ix > 0) {
     $p = $tp->findDir($cd);
     $dir = substr($b,0,$ix);
     if (!$E{$cd.$dir}) {
       push(@$p, $tp->findDir($dir));
       $E{$cd.$dir} = 1;
     }

     $ix = index($b, "/", $ix+1);
     $cd = $dir;
  }
  $p = $tp->findDir($cd);
  push(@$p, Leaf->new([$b, $url]));
}


sub read {
  my($tp, $el,$document, $openList) = @_;
  my($a, $i, $level, $v, $CNT, $vidx,$parent, $parentx, $j, %IDX,$doc,$doc_url);
  my($doc_ix, $q);
  $q = $tp->{q};
  my @openL  = split(/\|/, $openList);

  @Child = (); @IDX = (); @URL = ();
  $doc = 0; $doc_url = "";
  foreach $a (@$el) {
    if (substr($a->[0],0,1) eq "/") {$a->[0] = substr($a->[0],1)}
    $b = $a->[0] . "/";
    $i = index( $b, "/");
    $level = 0; $parent = ""; $parentx = 0; $j = 0;
    while ($i >= 0) {
       $v = substr($a->[0],0,$i + $j);
       if ($IDX{$v} eq "") {
          $CNT++; $IDX{$v} = $CNT; $IDX[$CNT] = $v; 
          if ($i == rindex($b,"/")) {
              $URL[$CNT] = $a->[1]; $GIF[$CNT] = $a->[2]; 
              $EXTRA[$CNT] = $a->[3]; $TARGET[$CNT] = $a->[4];
          }
       }
       $vidx = $IDX{$v};
       if ($openL[0] && $a->[0] =~ /$openL[0]/ ||
           $openL[1] && $a->[0] =~ /$openL[1]/ ) {
          $q->{open} .= ",$vidx";
       }
       if ($document ne "" && $a->[0] =~ /$document/ && $a->[1]) {
         $doc = $vidx; $doc_url = $a->[1];
       }
       if (index($Child[$parentx], "\t$vidx,") < 0) {
#         $Child[$parentx] .= "$vidx,";
         $Child[$parentx] .= "$v\t$vidx,";
       }
       $Parents[$vidx] = $parentx;
       
       $parentx = $vidx;
       $b = substr($b, $i+1);
       $j += $i + 1;
       $i = index($b, "/");
    }
  }
  $doc_ix = "";
  if ($doc) {
     $doc_ix .= ",$doc"; $d = $doc;
     while ($Parents[$d]) {
       $doc_ix .= ",$Parents[$d]";
       $d = $Parents[$d];
     }
  }
  my $this = $tp->{this};
  my ( @f, @a);

  $q->{open} .= $doc_ix;
  $opens = ($q->{open}) ? $q->{open} : "0";

  return ($doc_url,$tp->paint(0,0, $opens , ()));
}


$AL="align=top";

sub paint {
 my($tp, $level, $v, $opens, @more) = @_;
 my($x, $w, $o, $i, $v0, $open, $q);

 $q = $tp->{q};

 if (index(",$opens,",",$v,") >= 0) {
    $open = 1;
 } elsif ($q->{level} >= $level) {
    $opens .= ",$v";
    $open = 1;
 }
 $HE = "";
 if ($level > 0) {
   for ($i=0; $i < $#more; $i++) {
     if ($more[$i]) {
       $o .= "<img src=$tp->{sysgif}/line.gif $AL $HE>";
     } else {
       $o .= "<img src=$tp->{sysgif}/space.gif $AL $HE> ";
     } 
   }
   
   if ($Child[$v] ne "") {
    if ($open) {
       $o1 = "$opens,";
       $o1 =~ s/$v,//;
       if (substr($o1,length($o1)-1) eq ",") {chop($o1)}
       
       $o .= "<a href=$tp->{this}&open=$o1>" .
             "<img src=$tp->{sysgif}/minus.gif $AL border=0 $HE></a>";
    } else {
       $o .= "<a href=$tp->{this}&open=$opens,$v>" .
             "<img src=$tp->{sysgif}/plus.gif $AL border=0 $HE></a>";
    }
   } elsif ($more[$#more]) {
    $o .= "<img src=$tp->{sysgif}/item1.gif $AL $HE>";
   } else {
    $o .= "<img src=$tp->{sysgif}/item0.gif $AL $HE>";
   }
   $v0 = $IDX[$v];
   $ix = rindex($v0,"/");
   if ($ix > 0) {$v0 = substr($v0,$ix+1)}
   $targ =""; 
   if ($TARGET[$v]) {
      $targ = " target=$TARGET[$v]";
   } elsif ($tp->{target} ne "") {
      $targ = " target=$tp->{target}";
   }
   $v0 = " $v0 " if (length($v0) == 1);
   $v0 = "<b>$v0</b>" if ($level == 1 && $tp->{bold1});
   if ($URL[$v] eq '') {
      $o .= "$v0<br>\n";
   } else {
      $gif = ($GIF[$v] ne "") ? "<img src=$GIF[$v] $AL $HE>":"";
      $o .= "$gif<a href=$URL[$v]$targ>$v0</a>&nbsp;$EXTRA[$v]<br>\n";
   }
 }

 if ($open) {
    my(@chlds) = split(/,/, $Child[$v]);
  
    $x = 0;
    foreach $ch (sort @chlds) {
      $ch0 = substr($ch,index($ch,"\t")+1);
      $o .= $tp->paint($level+1,$ch0, "$opens", (@more,$x < $#chlds));
      $x++;
    }
 }
 $o;
}


package Dir;

sub new {
  my($class, $self) = @_;
  bless($self, "Dir");
  return $self;
}

package Leaf;

sub new {
  my($class, $self) = @_;
  bless($self, "Leaf");
  return $self;
}




    
1;
