package Util::Http;
#  $Name:  $ 
#  $Id: Http.pm,v 1.3 2000/12/08 23:25:13 ccadieux Exp $

use Debug;
use LWP::UserAgent;

#$Util::Http->post(page, $text, 20);
#$Util::Http->post(page, $text, {timeout => 20} );

sub post {
  my($self, $page, $post, $arg) = @_;
  if (ref($arg) eq "HASH") {
    $to = $arg->{timeout};
    $proxy = $arg->{proxy} ;
  } elsif ($arg) {
    $to = $arg;
  }
  $to = 30 if (!$to);

  my($ua) = new LWP::UserAgent;
  if ($to =~ /\d+/) {
    $ua->timeout($to); 
  }

#  $ua->agent("AgentName/0.1 " . $ua->agent);
  $ua->proxy('http' => $proxy) if ($proxy);

  my($req) = new HTTP::Request(POST => $page);
  $req->content_type('application/x-www-form-urlencoded');
  $req->content($post . "\n");
  my($res) = $ua->simple_request($req);

  if ($res->is_success) {
    return (0, $res->content);
  } else {
    return ($res->code, $res->status_line);
  }
}


$ERROR = "";

sub get {
  my($self, $page,$timeout) = @_;

  my($ua) = new LWP::UserAgent;
  $timeout = 30 if (!$timeout);
  if ($timeout =~ /\d+/) {
    $ua->timeout($timeout) ;
  }

#  $ua->agent("AgentName/0.1 " . $ua->agent);
#  $ua->proxy('http' => "http://cache-brm.Central.Sun.COM:8080");

 my($req) = new HTTP::Request(GET => $page);
 my($res) = $ua->request($req);

 if ($res->is_success) {
    Debug->snapshot("Http->get(to=$timeout): $page");
    Debug->snapshot1($res->content);
    return $res->content;
 } else {
    $ERROR = $res->status_line;
    Debug->snapshot("Http->get(to=$timeout): $page\nError: " . $res->code . " " .  $res->status_line);
    return undef;
 }
}

1;

