
sub ping {
  my($host_ip, $prompt, $timeout) = @_;
  $timeout = 10 if (!$timeout);
  $t = new Net::Telnet (
                  errmode   => "return",
                  Timeout   => $timeout,
                  Prompt    => $prompt,
           );
  if (!defined($t->open($host_ip))) {
     return 0;
  }
  $t->close;
  return 1;
}

sub telnet {
  my($host_ip, $cmd,  $timeout, $prompt, $login) = @_;
  my($t, @lines);
  my($pass) = "";

  if (($i = index($login,"/")) > 0) {
     $pass = substr($login,$i+1);
     $login = substr($login,0, $i);
  }
  $timeout = 60 if (!$timeout);

#'/' . $prompt . ':\/:\<\d+\>/',

  $t = new Net::Telnet (
                  errmode => "return",
                  Timeout   => $timeout,
                  Prompt    => $prompt,
           );
  if (!defined($t->open($host_ip))) {
     return undef;
  }
  $t->login($login, $pass);
  @lines = $t->cmd($cmd);
  $t->close;

  return \@lines;

}

1;

